#include <stdio.h>
#include <dos.h>
#include <fcntl.h>
#include <sys\types.h>
#include <sys\stat.h>

#include "common.h"
#include "extern.h"

unsigned int WORD2INT( unsigned char far *p )
{
	return (
	(( p[1] << 8 ) & 0xFF00 ) +
	( p[0]         & 0x00FF )
	);
}

long _filesize( char *filename )
{
	struct stat		st;

	if( stat( filename, &st ) != 0 )
	{
		printf( MES[MES_FILENOTFOUND], filename );
		return -1;
	}

	return ( long )st.st_size;
}

long _far_fileload( char *filename, unsigned char far *p )
{
	long				filesize;
	int					in;
	unsigned int		readsize;

	filesize = _filesize( filename );
	if( filesize == -1 )
	{
		printf( MES[MES_FILENOTFOUND], filename );
		return -1;
	}

	_dos_open( filename, O_RDONLY, &in );
	_dos_read( in, p, filesize, &readsize );
	_dos_close( in );

	printf( INFO[INFO_LOAD], filename, ( long )readsize );

	return ( long )readsize;
}

unsigned char far *_far_calloc( long size )
{
	unsigned char far	*p;

	p = ( unsigned char far * )farcalloc( 1, size );
	if( p == NULL ) printf( MES[MES_ALLOCMEM] );

	return p;
}

void _readvect( int vec, int mode, int offset, char *buf )
{
	unsigned char far	*p = NULL;
	int 				i;

	vect = _dos_getvect( vec );
	p = ( unsigned char far *)vect;

#ifdef _DEBUG
printf( "Vect   : %02X %08Fp\n", vec, p );
#endif

	if( mode == 1 )
	{
		unsigned short	seg = FP_SEG( p );

		if( offset < 0 )
		{
			seg--;
			offset *= -1;
		}
		p = MK_FP( seg, 0x0000 );
		p += offset;
	} else p += offset;

#ifdef _DEBUG
printf( "Vectr  : %02X %08Fp\n", vec, p );
#endif

	for( i = 0; i != 16; i++ )
	{
		buf[i] = *( p + i );
	}
}
